

import ProSW.*;
import java.util.*;

public class PretAPorter extends AutInv {
	
	private /*@ spec_public non_null @*/ final String fasciaMercato;

	/*@	assignable fasciaMercato;
	 	ensures fasciaMercato == mercato;
	    signals_only EccezionePrecondizioni;
	 @*/
	public PretAPorter (int cod, String tema, int anno, boolean pell, Stilista s, String mercato) throws EccezionePrecondizioni {
		super(cod,tema,anno,pell,s);
		if (mercato==null) throw new EccezionePrecondizioni("La fascia mercato non puo' essere null");
		fasciaMercato=mercato;
	}
	
	public /*@  pure  @*/ String getMercato(){ return fasciaMercato; }
	
	// Gestione associazione Acquista (1..*)
	private /*@ spec_public @*/ Set linkAcquista = new HashSet();
	
	/*@  
		 signals_only EccezionePrecondizioni;	 
	 @*/
	public void inserisciLinkAcquista(Azienda azienda, int nCapi) 
		  throws EccezionePrecondizioni {
		
	  	linkAcquista.add( new TipoLinkAcquista(this, azienda, nCapi) );
	}
	
	/*@  requires linkAcquista.size() >= 1;
		 ensures \result == linkAcquista;		 
		 signals_only EccezioneMolteplicita;	 
	 @*/
	public /*@  pure  @*/ Set getLinkAcquista() throws EccezioneMolteplicita {
		if (linkAcquista.size() < 1)
			throw new EccezioneMolteplicita("I vincoli di molteplicita' dell'associazione 'Acquista' sono violati");
		return (Set)((HashSet)linkAcquista).clone(); 
	}
} //:~