package ProSW;

import java.util.*;

public class Data implements Cloneable {

	// Senza side-effect, rappresenta oggetti immutabili

  private int giorno, mese, anno;

  public Data(int g, int me, int a) throws EccezionePrecondizioni {
    giorno = g;
    mese = me;
    anno = a;
    if (!valida()) throw new EccezionePrecondizioni("Data non valida");
  }
  
  // Ritorna la data corrente
  public Data() {
	  Calendar cal = Calendar.getInstance();
	  giorno = cal.get(Calendar.DATE);
	  mese = cal.get(Calendar.MONTH);
	  anno = cal.get(Calendar.YEAR);
  }
  
  
  
  public int getGiorno() {
    return giorno;
  }
  public int getMese() {
    return mese;
  }
  public int getAnno() {
    return anno;
  }
  public boolean prima(Data d) {
    return ((anno < d.anno)
            ||  (anno == d.anno && mese < d.mese)
            ||  (anno == d.anno && mese == d.mese && giorno < d.giorno));
  }
  public Data domani() {
	int g = giorno;
	int m = mese;
	int a = anno;
    if (g == giorniDelMese())
      if (m == 12) {
        g = 1;
        m = 1;
        a++;
      }
      else {
        g = 1;
        m++;
      }
    else
      g++;
	
	try {
		return new Data(g,m,a);
	} catch(EccezionePrecondizioni e) {
		throw new InternalError("Attenzione: errore nel calcolare domani()");
	}
  }
  public String toString() {
    return giorno + "/" + mese + "/" + anno;
  }
  public Object clone() {
    try {
      Data d = (Data)super.clone(); 
      return d;
    } catch (CloneNotSupportedException e) {
    // non puo' accadere, ma va comunque gestito
      throw new InternalError(e.toString());
    }
  }
  public boolean equals(Object o) {
    if (o != null && getClass().equals(o.getClass())) {
      Data d = (Data)o;
      return d.giorno == giorno && d.mese == mese && d.anno == anno;
    }
    else return false;
  }
  public int hashCode() { return giorno+mese+anno; }

  private int giorniDelMese() {
    switch (mese) {
    case 2:
      if (bisestile()) return 29;
      else return 28;
    case 4: case 6: case 9: case 11: return 30;
    default: return 31;
    }
  }
  private boolean bisestile() {
	if (anno % 100 == 0) {
		if (anno % 400 == 0) return true;
		else return false;
	}
	else return (anno % 4 == 0);
  }
  private boolean valida() {
    return anno > 0 && anno < 3000
      && mese > 0 && mese < 13 
      && giorno > 0 && giorno <= giorniDelMese();
  }
} //:~