package ProSW;

// Questa classe modella oggetti **immutabili**
public class DataOra implements Cloneable {   

    private final Data data;
	private final Ora ora;

    public DataOra(Data d, Ora o) throws EccezionePrecondizioni {
	   if (d == null) throw new EccezionePrecondizioni("La data non puo' essere null");
	   data = d; // (La classe Data non permette side-effect!)
	   
   	   if (o == null) throw new EccezionePrecondizioni("L'ora non puo' essere null");
	   ora = o; // (La classe Ora non permette side-effect!)
	}
	
	public DataOra(Data d) throws EccezionePrecondizioni {
		this(d, new Ora(0,0,0));
	}

    // Ritorna data/ora correnti
	public DataOra() {
	  data = new Data();
	  ora = new Ora();
	}
	
    public Data getData() { return data; }
    public Ora getOra()   { return ora; }

    public int oreDiDistanza(DataOra momentoPrecedente) { 
	  return 0; /* DA REALIZZARE PER ESERCIZIO */ 
	}
	public int giorniDiDistanza(DataOra momentoPrecedente) { 
	  return 0; /* DA REALIZZARE PER ESERCIZIO */
	}

    public DataOra calcolaVariazione(int diffGiorni, int diffMesi, int diffAnni, 
                                  int diffOre, int diffMinuti) { 
	  return null; /* DA REALIZZARE PER ESERCIZIO */ 
	}
	public static int ANNI = 0;
	public static int MESI = 1;
	public static int GIORNI = 2;		
	public static int ORE = 3;	
	public static int MINUTI = 4;	
	public static int SECONDI = 5;	
	public double differenza(DataOra altra, int unita) {
		if (unita < 0 || unita > 5) throw new InternalError("Errore: unita' non valida!");
		// DA REALIZZARE PER ESERCIZIO
		return 0;
	}

	
	public boolean primaDi(DataOra altroMomento) {
	    return data.prima(altroMomento.data) ||
		       (data.equals(altroMomento.data) && ora.prima(altroMomento.ora));
	}

	public boolean primaDiOUgualeA(DataOra altroMomento) {
		return this.primaDi(altroMomento) || this.equals(altroMomento);
	}

    // Funzioni ereditate da Object
    public String toString() {
		return data.toString() + ", " + ora.toString();
	}
    public boolean equals(Object o) {
		if (o != null && getClass().equals(o.getClass())) {
			DataOra d = (DataOra)o;
			return data.equals(data) && ora.equals(ora);
		}
	    else return false;
	}
	public int hashCode() { return data.hashCode()+ora.hashCode(); }
  
    public boolean equalsIgnoreTime(Object o) {
		if (o != null && getClass().equals(o.getClass())) {
			DataOra d = (DataOra)o;
			return data.equals(d.data);
		}
	    else return false;
	}


    public Object clone() {
		try {
			DataOra d = (DataOra)super.clone(); 
			// Posso evitare di duplicare 'data' e 'ora' perche'
			// le rispettive classi non permettono side-effect
			// (accetto condivisione di memoria)
			return d;
		} catch (CloneNotSupportedException e) {
			// non puo' accadere, ma va comunque gestito
			throw new InternalError(e.toString());
		}
	}

} //:~
