package ProSW;

import java.util.*;

public class Ora implements Cloneable {

	// Senza side-effect, rappresenta oggetti immutabili

  private int ore, minuti, secondi;

  public Ora(int h, int m, int s) throws EccezionePrecondizioni {
    if (h < 0 || h > 23) throw new EccezionePrecondizioni("Le ore devono essere comprese tra 0 e 23");
	ore = h;
	
	if (m < 0 || m > 59) throw new EccezionePrecondizioni("I minuti devono essere comprese tra 0 e 59");
	minuti = m;

	if (s < 0 || s > 59) throw new EccezionePrecondizioni("I secondi devono essere comprese tra 0 e 59");
	secondi = s;
	
  }
  
  // Ritorna l'ora corrente
  public Ora() {
	  Calendar cal = Calendar.getInstance();
	  ore = cal.get(Calendar.HOUR);
	  minuti = cal.get(Calendar.MINUTE);
	  secondi = cal.get(Calendar.SECOND);
  }  
  
  public int getOre() { return ore; }
  public int getMinuti() { return minuti; }
  public int getSecondi() { return secondi; }

  public boolean prima(Ora o) {
    return ((ore < o.ore)
            ||  (ore == o.ore && minuti < o.minuti)
            ||  (ore == o.ore && minuti == o.minuti && secondi < o.secondi));
  }

  public String toString() {
    return ore + ":" + minuti + ":" + secondi;
  }
  public Object clone() {
    try {
      Ora o = (Ora)super.clone(); 
      return o;
    } catch (CloneNotSupportedException e) {
    // non puo' accadere, ma va comunque gestito
      throw new InternalError(e.toString());
    }
  }
  public boolean equals(Object o) {
    if (o != null && getClass().equals(o.getClass())) {
      Ora oo = (Ora)o;
      return ore == oo.ore && minuti == oo.minuti && secondi == oo.secondi;
    }
    else return false;
  }
  public int hashCode() { return secondi + minuti*60 + ore*3600; }

} //:~