
import ProSW.*;

public class Stilista {
	private /*@ spec_public non_null @*/ final String nome;
	private /*@ spec_public @*/int anniEsp;
	//@ invariant anniEsp>=0;

	/*@	requires n!=null;
	    assignable nome,anniEsp;
	 	ensures (nome == n) && (anniEsp == a);
	    signals_only EccezionePrecondizioni;
	 @*/
	public Stilista(String n, int a) throws EccezionePrecondizioni {
		if (n==null) throw new EccezionePrecondizioni("Il nome non puo' essere null");
		nome=n;
		setAnniEsperienza(a);
	}
	
	/*@ 
	     requires a>=0;
	     assignable anniEsp;
		 ensures anniEsp == a;		 
		 signals_only EccezionePrecondizioni;	 
	 @*/
	public void setAnniEsperienza(int a) throws EccezionePrecondizioni {
		if (a<0) throw new EccezionePrecondizioni("a deve essere positivo o nullo");
		anniEsp=a;
	}
	
	public /*@  pure  @*/ String getNome() { return nome; }
	
	public /*@  pure  @*/ int getAnniEsperienza() { return anniEsp; }

	public /*@  pure  @*/ String toString() {
		return nome + " (" + anniEsp + " anni di esperienza)";
	}

} //:~