
import ProSW.*;

public class TipoLinkAcquista {
	
  private /*@ spec_public @*/ final PretAPorter pretaporter;
  private /*@ spec_public @*/ final Azienda azienda;
  private /*@ spec_public @*/ final int nCapi;
  
  //* invariant pretaporter!=null
  //* invariant azienda!=null
  //* invariant nc>0

	/*@	requires x!= null && y!=null && nc>0;
	    assignable pretaporter,azienda,nCapi;
	 	ensures pretaporter == x && azienda == y && nCapi == nc;
	    signals_only EccezionePrecondizioni;
	 @*/
	  public TipoLinkAcquista(PretAPorter x, Azienda y, int nc) throws EccezionePrecondizioni {
		  
		if (x == null) throw new EccezionePrecondizioni("pretaporter non puo' essere null");
		pretaporter = x;
		
		if (y == null) throw new EccezionePrecondizioni("azienda non puo' essere null");	
		azienda = y;
		
		if (nc <=0) throw new EccezionePrecondizioni("Il num. di capi deve essere > 0");	
		nCapi = nc;
	
	  }
  
	  public /*@  pure  @*/ PretAPorter getPretAPorter() { return pretaporter; }
	  public /*@  pure  @*/ Azienda getAzienda() { return azienda; }
	  public /*@  pure  @*/ int getNCapi() { return nCapi; }

  

 
  public int hashCode() { return pretaporter.hashCode()+azienda.hashCode(); }
} //:~
