
import java.util.*;
import ProSW.*;

public final class VerificheSfilate {
	
	/*@	requires s!= null;
	 	ensures (* \result ==  verifica se la media degli anni d'esperienza degli stilisti< 5   *);
	    signals_only EccezionePrecondizioni,EccezioneMolteplicita;
	 @*/
	public static boolean verificaEsordienti(Sfilata s) throws EccezionePrecondizioni, EccezioneMolteplicita {
		if (s==null) throw new EccezionePrecondizioni("La sfilata non puo' essere null");
		Set insLink = s.getLinkPresentata();
		Iterator it=insLink.iterator();
		double somma=0;
		while (it.hasNext()) {
			Collezione c = (Collezione) it.next();
			int anniStilista = c.getAppartiene().getAnniEsperienza();
			somma = somma + anniStilista;
		}
		return ((somma/insLink.size())<5);
	}


	/*@	requires c!= null && PretAPorter.class.isInstance(c);
	 	ensures  (* \result == numero di capi acquistati da aziende con capitale maggiore di 10 milioni *);
	 	signals_only EccezionePrecondizioni,EccezioneMolteplicita;
	 	also
	 	requires !PretAPorter.class.isInstance(c);
	 	ensures \result ==0;
	    signals_only EccezionePrecondizioni,EccezioneMolteplicita;
	 @*/
	public static int calcolaVendite(Collezione c) throws EccezionePrecondizioni, EccezioneMolteplicita {
		if (c==null) throw new EccezionePrecondizioni("La collezione non puo' essere null");
		if (!PretAPorter.class.isInstance(c)) return 0;
				
		PretAPorter p = (PretAPorter)c;
		Iterator it = p.getLinkAcquista().iterator();
		int result=0;
		while (it.hasNext()) {
			TipoLinkAcquista l = (TipoLinkAcquista) it.next();
			if (l.getAzienda().isMedioGrande())
				result += l.getNCapi();
		}
		return result;
	}
} //:~	
